#!/bin/csh -f


if ( $#argv != 3 ) then
    echo "Usage : "$0" (FITS data table) (# of dithering point) (Output Image Name)"
    exit 1
endif

set FTABLE=$1
set NPOINT=$2
set HEADER=`gawk -v hd=$3 'BEGIN{gsub(".fits","",hd);gsub(".imh","",hd);print(hd)}'`
set OUTIM=$HEADER".fits"

set NFRAME=`gawk -v np=$NPOINT 'END{print(NR/np)}' $FTABLE`
echo $NFRAME

echo "### Erase objects ###"
echo "imdel @mldata.tbl" | cl
set i=1
while($i <= $NPOINT)
  gawk -v p=$i -v f=$NFRAME '{if(NR>(p-1)*f && NR<=p*f) print $0}' ldata.tbl > ldata.tmp.tbl
  sed 's/ldata/mldata/g' ldata.tmp.tbl > mldata.tmp.tbl
#  set ii=`gawk -v n=$i 'BEGIN{printf("%03d\n",i)}'`
  echo "eraseobj @ldata.tmp.tbl @mldata.tmp.tbl MASK/$HEADER."`gawk -v n=$i 'BEGIN{printf("%03d\n",n)}'`".tbl" | cl
  @ i += 1
end

echo "imdel @ldata.tbl" > cl.com
echo "imcopy @mldata.tbl  @ldata.tbl" >> cl.com
echo "imarith @ldata.1.tbl + sky1 @ldata.1.tbl" >> cl.com
echo "imarith @ldata.2.tbl + sky2 @ldata.2.tbl" >> cl.com
echo "logout" >> cl.com
cat cl.com | cl

echo "### Re-create sky frames ###"
awk '{s+=$1;i++;}END{print(s/i)}' level.tbl > tmp.txt
echo "imdel noobjsky1,noobjsky2" > cl.com
echo "imdel noobjsky*.imh" >> cl.com
echo "del bkg1.tbl,bkg2.tbl" >> cl.com
echo "logout" >> cl.com
cat cl.com | cl
gawk -v nf=1 '{print("mksubgr @ldata.1.tbl noobjsky1 1 "nf" "$1" 257 768 257 768 bkg1.tbl")}' tmp.txt | cl
gawk -v nf=$NFRAME '{print("mksubgr @ldata.2.tbl noobjsky2 1 "nf-1" "$1" 257 768 257 768 bkg2.tbl")}' tmp.txt | cl

echo "### $0 Finished ###"
echo "imdel RESULTS/$HEADER.noobjsky1.fits" > cl.com
echo "imdel RESULTS/$HEADER.noobjsky2.fits" >> cl.com
echo "imcopy noobjsky1.imh RESULTS/$HEADER.noobjsky1.fits" >> cl.com
echo "imcopy noobjsky2.imh RESULTS/$HEADER.noobjsky2.fits" >> cl.com
echo "logout" >> cl.com
cat cl.com | cl

echo "Sky Image is "RESULTS/$HEADER.noobjsky1.fits
echo "             "RESULTS/$HEADER.noobjsky2.fits

echo "imdel @ldata.tbl" > cl.com
echo "imdel @mldata.tbl" >> cl.com
echo "imdel noobjsky1.imh" >> cl.com
echo "imdel noobjsky2.imh" >> cl.com
echo "logout" >> cl.com
cat cl.com | cl
